<?PHP
/*************************************************************************
SK Dismiss Notices. v. 1.1.0 - 2008.08.08
http://www.sk-software.com

/SK
*************************************************************************/

// ####################### SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('THIS_SCRIPT', 'dismissnotice');
define('CSRF_PROTECTION', true);
define('CSRF_SKIP_LIST', '');

// ######################### REQUIRE BACK-END ############################
require_once('./global.php');

function fetch_dismissed_notices()
{
	global $vbulletin;
	
	$dismissed_notices = array();
	if( $vbulletin->userinfo['dismissed_p_notices'] )
	{
		$notices_result = $vbulletin->db->query_read(
			"SELECT noticeid
			 FROM " . TABLE_PREFIX . "notice
			 WHERE noticeid IN(" . $vbulletin->userinfo['dismissed_p_notices'] . ")
			 ORDER BY displayorder, title");
		while( $notice = $vbulletin->db->fetch_array($notices_result) )
		{
			$dismissed_notices[] = $notice['noticeid'];
		}
		$vbulletin->db->free_result($notices_result);
	}
	
	return $dismissed_notices;
}

function save_dismissed_notices( $dismissed_notices )
{
	global $vbulletin;
	
	$userdata =& datamanager_init('User', $vbulletin, ERRTYPE_STANDARD);  
	$userdata->set_existing($vbulletin->userinfo); 
	$userdata->do_set('dismissed_p_notices', implode( ",", $dismissed_notices ) );  
	$userdata->save();
}

if( $_REQUEST['do'] == 'dismiss' )
{
	if( $vbulletin->userinfo['userid'] > 0 AND ($permissions['skdismissnoticespermissions'] & $vbulletin->bf_ugp['skdismissnoticespermissions']['candismissnotices']) )
	{
		$vbulletin->input->clean_array_gpc('r', array(
			'id' => TYPE_UINT
		));
		
		$dismissed_p_notices = fetch_dismissed_notices();
		if( intval( $vbulletin->GPC['id'] ) > 0) $dismissed_p_notices[] = intval( $vbulletin->GPC['id'] );
		
		save_dismissed_notices( $dismissed_p_notices );
	}
	
	standard_redirect( $vbulletin->url );
}

if( $_REQUEST['do'] == 'activate' )
{
	if( $vbulletin->userinfo['userid'] > 0 )
	{
		$vbulletin->input->clean_array_gpc('p', array( 
			'dismissednotice' => TYPE_ARRAY_BOOL, 
			'set_dismissednotice' => TYPE_ARRAY_BOOL 
		)); 
	
		$dismissed_p_notices = fetch_dismissed_notices();
		$new_dismissed_p_notices = array();
		foreach( $dismissed_p_notices AS $id )
		{
			if( (isset( $vbulletin->GPC['set_dismissednotice'][$id] ) AND !isset( $vbulletin->GPC['dismissednotice'][$id] )) OR
			    !isset( $vbulletin->GPC['set_dismissednotice'][$id] ) )
			{
				$new_dismissed_p_notices[] = $id;
			}
		}
			
		save_dismissed_notices( $new_dismissed_p_notices );
	}
	
	standard_redirect( $vbulletin->url );
}

?>